#include <stdio.h>
#include <stdlib.h>

struct element
{
  int v;
  struct element *n;
};

static struct element *head = NULL;

int
insertElement (int v)
{
  if (v < 0)
    {
      return -1;
    }

  if (head == NULL)
    {
      struct element *neuesElement = malloc (sizeof (struct element));
      if (neuesElement == NULL)
        {
          return -1;
        }
      neuesElement->v = v;
      neuesElement->n = NULL;
      head = neuesElement;
    }
  else
    {
      struct element *last = head;
      while (last->n != NULL)
        {
          if (last->v == v)
            {
              return -1;
            }
          last = last->n;
        }
      if (last->v == v)
        {
          return -1;
        }

      struct element *neuesElement = malloc (sizeof (struct element));
      if (neuesElement == NULL)
        {
          return -1;
        }
      neuesElement->v = v;
      neuesElement->n = NULL;
      last->n = neuesElement;
    }

  return v;
}

int
removeElement (void)
{
  if (head == NULL)
    {
      return -1;
    }

  int res = head->v;
  struct element *newHead = head->n;
  free (head);
  head = newHead;

  return res;
}

int
main (int argc, char *argv[])
{
  printf ("insert 11: %d\n", insertElement (11));
  printf ("insert 47: %d\n", insertElement (47));
  printf ("insert 11: %d\n", insertElement (11));
  printf ("insert 47: %d\n", insertElement (47));

  printf ("remove: %d\n", removeElement ());

  printf ("insert 23: %d\n", insertElement (23));

  printf ("remove: %d\n", removeElement ());

  // TODO: add more tests

  exit (EXIT_SUCCESS);
}
